﻿using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Xml;
using System.Data.OleDb;

using Syncfusion.Windows.Forms;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Chart;

namespace WindowsFormsApplication6
{
    public partial class Form1 : Form
    {
        private string tableName = "Products";
        private ChartDataBindModel model1;
        private ChartDataBindModel model2;
        private ChartDataBindModel model3;
        private ChartDataBindModel model4;
        private ChartDataBindAxisLabelModel xAxisLabelModel = null;
        public Form1()
        {
            InitializeComponent();
            string fileName = WinFormsUtils.FindFile(@"\", "ChartData.xls");

            //The Oledbconnection.
            OleDbConnection excelConn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + fileName + ";Extended Properties=\"Excel 8.0;HDR=Yes;\"");
            excelConn.Open();

            //Query for retriving the data from the excel sheet.
            string query = "Select * From [Sheet1$A1:E6]";

            OleDbCommand excelCommand = new OleDbCommand(query, excelConn);

            OleDbDataReader excelReader = excelCommand.ExecuteReader(CommandBehavior.CloseConnection);

            //Load the contents to a dataset.
            DataSet excelDataSet = ConvertToDataSet(excelReader, "ExcelTable");



            this.chartControl1.Indexed = true;

            //Initializes new chart series.
            ChartSeries series = new ChartSeries();
            series.Name = tableName;
            series.Type = ChartSeriesType.Column;
            model1 = new ChartDataBindModel(excelDataSet, "ExcelTable");
            model1.XName = "ID";
            model1.YNames = new string[] { "2012 Year" };
            series.SeriesModel = model1;
         
            this.chartControl1.Series.Add(series);

            //Initializes new chart series.
            ChartSeries series1 = new ChartSeries();
            series1.Name = tableName;
            series1.Type = ChartSeriesType.Column;
            model2 = new ChartDataBindModel(excelDataSet, "ExcelTable");
            model2.XName = "ID";
            model2.YNames = new string[] { "2013 Year" };
            series1.SeriesModel = model2;
            this.chartControl1.Series.Add(series1);

            //Initializes new chart series.
            ChartSeries series2 = new ChartSeries();
            series2.Name = tableName;
            series2.Type = ChartSeriesType.Column;
            model3 = new ChartDataBindModel(excelDataSet, "ExcelTable");
            model3.XName = "ID";
            model3.YNames = new string[] { "2014 Year" };
            series2.SeriesModel = model3;
            this.chartControl1.Series.Add(series2);

            this.xAxisLabelModel = new ChartDataBindAxisLabelModel(excelDataSet, "ExcelTable");
            this.xAxisLabelModel.LabelName = "Division";
            //Adds the series to the ChartSeriesCollection.
            this.chartControl1.Series.Add(series);
            this.chartControl1.PrimaryXAxis.TickLabelsDrawingMode = ChartAxisTickLabelDrawingMode.UserMode;
            this.chartControl1.PrimaryXAxis.LabelsImpl = this.xAxisLabelModel;
            this.chartControl1.Skins = Skins.Metro;
            //Close the connection.
            excelReader.Close();
            excelConn.Close();
            this.chartControl1.PrimaryXAxis.HidePartialLabels = true;
            this.chartControl1.Text = "Chart Data From Excel";
            this.chartControl1.Legend.Visible = false;
            this.chartControl1.PrimaryYAxis.Format = "$##";
        }
        protected DataSet ConvertToDataSet(OleDbDataReader dataReader, string tableName)
        {
            DataSet dataSet = new DataSet();
            do
            {
                // Create new data table

                DataTable schemaTable = dataReader.GetSchemaTable();
                DataTable dataTable = new DataTable(tableName);

                if (schemaTable != null)
                {
                    // A query returning records was executed

                    for (int i = 0; i < schemaTable.Rows.Count; i++)
                    {
                        DataRow dataRow = schemaTable.Rows[i];
                        // Create a column name that is unique in the data table
                        string columnName = (string)dataRow["ColumnName"]; //+ "<C" + i + "/>";
                        // Add the column definition to the data table
                        DataColumn column = new DataColumn(columnName, (Type)dataRow["DataType"]);
                        dataTable.Columns.Add(column);
                    }

                    //Add the data table to the dataset.
                    dataSet.Tables.Add(dataTable);

                    // Fill the data table.
                    while (dataReader.Read())
                    {
                        DataRow dataRow = dataTable.NewRow();

                        for (int i = 0; i < dataReader.FieldCount; i++)
                            dataRow[i] = dataReader.GetValue(i);

                        dataTable.Rows.Add(dataRow);
                    }
                }
                else
                {
                    // No records were returned.

                    DataColumn column = new DataColumn("RowsAffected");
                    dataTable.Columns.Add(column);
                    dataSet.Tables.Add(dataTable);
                    DataRow dataRow = dataTable.NewRow();
                    dataRow[0] = dataReader.RecordsAffected;
                    dataTable.Rows.Add(dataRow);
                }
            }
            while (dataReader.NextResult());
            return dataSet;
        }
    }
}
